#include "../include/utilities.h"

void resizeWindow(int width, int height)
{
    char* command = (char*) malloc (strlen("mode 34400,14400 & powershell -command \"&{$H=get-host;$W=$H.ui.rawui;$B=$W.buffersize;$B.height=3000;$W.buffersize=$B;}\\") + 10);
    sprintf(command,"mode %d,%d",width,height);
    system(command);   //Set mode to ensure window does not exceed buffer size*/
    SMALL_RECT WinRect = {0, 0, width, height};   //New dimensions for window in 8x12 pixel chars
    SMALL_RECT* WinSize = &WinRect;
    SetConsoleWindowInfo(GetStdHandle(STD_OUTPUT_HANDLE), 1, WinSize);   //Set new size for window

    COORD  BufferSize;

    BufferSize.X = width;
    BufferSize.Y = 10000;

    SetConsoleScreenBufferSize(GetStdHandle(STD_OUTPUT_HANDLE), BufferSize);   //Set new size for window
    free(command);
}
int compare(void const *a, void const *b) {
    FileBlock *aa = (FileBlock *)a;
    FileBlock *bb = (FileBlock *)b;

    char* aaa = (char*)aa->fileName;
    char* bbb = (char*)bb->fileName;

    return strcmp(aaa, bbb);
}

int compare_middle_digits(void const *a, void const *b) {
    FileBlock *aa = (FileBlock *)a;
    FileBlock *bb = (FileBlock *)b;

    char* ExtA = getFileExt((char*)aa->fileName);
    char* ExtB = getFileExt((char*)bb->fileName);

    char* middleExtA = concatenate(ExtA,getMiddleDigits((char*)aa->fileName));
    char* middleExtB = concatenate(ExtB,getMiddleDigits((char*)bb->fileName));

    char* middleExtNameA = concatenate(middleExtA,(char*)aa->fileName);
    char* middleExtNameB = concatenate(middleExtB,(char*)bb->fileName);

    return strcmp(middleExtNameA, middleExtNameB);
}

int compare_meta_offset(void const *a, void const *b) {
    FileBlock *aa = (FileBlock *)a;
    FileBlock *bb = (FileBlock *)b;

    long aaa = (long)aa->metaOffset;
    long bbb = (long)bb->metaOffset;

    return (aaa - bbb);
}

char* endian_convert(int num)
{
    char big_end[12];
    sprintf(big_end,"%.8x", num);

    char* little_end = (char*) malloc(9);
    int i = 0;

    for(i = 0; i < strlen(big_end); i +=2)
    {
        char firstNum = big_end[strlen(big_end) - i - 2];
        if (firstNum >= 'a' && firstNum <= 'f')
        {
            firstNum -= 32;
        }
        char secondNum = big_end[strlen(big_end) - i - 1];
        if (secondNum >= 'a' && secondNum <= 'f')
        {
            secondNum -= 32;
        }
        little_end[i] = firstNum;
        little_end[i+1] = secondNum;
    }
    little_end[8]  = '\0';
    return little_end;
}


void printMainHeader()
{

    printf("******************************************************\n");
    printf("*                                                    *\n");
    printf("*      Black Desert Online Resorepless v3.0d         *\n");
    printf("*                                                    *\n");
    printf("******************************************************\n");
}


char* getTwoDigits(char* fileName)
{
    int start = indexOf('_',fileName,0);
    int end = indexOf('_',fileName,1) + 1;

    char* twoDigits = substr(fileName,start,end);

    return twoDigits;
}

char* getMiddleDigits(char* fileName)
{
    int  start = indexOf('_',fileName,1) + 1;
    int end = indexOf('_',fileName,2);

    char* middle = substr(fileName,start,end);

    return middle;
}

char* getClassPrefix(char* fileName)
{
    return substr(fileName,0,3);
}

char* removeClassPrefix(char* fileName)

{
    int firstUnderlineIdx = indexOf('_', fileName,0);
    return substr(fileName,firstUnderlineIdx, strlen(fileName));
}

char* getLastFolder(char* folderName)
{
    int i = strlen(folderName);
    int start = 0;
    int skipped = 0;
    for ( i = strlen(folderName); i >=0; i--)
    {
        if (folderName[i] == '/')
        {
            if (skipped == 0)
            {
                skipped = 1;
            }
            else
            {
                start = i + 1;
                break;
            }
        }
    }
    return substr(folderName,start,strlen(folderName) - 1);
}

int contains(char* fullString, char* substring)
{
    if (strlen(substring) > strlen(fullString))
    {
        //printf("\nWarning: Wrong use of function 'contains(%s,%s)'. The first argument has to be longer than the second", fullString, substring);
        return 0;
    }
    int i = 0;
    int j = 0;
    int combo = 0;
    for (i = 0; i < strlen(fullString); i++)
    {
        if (substring[j] == fullString[i]
        || substring[j] + 32 == fullString[i]
        || substring[j] - 32 == fullString[i]
        || (substring[j] == '/' && fullString[i] == '\\')
        || (substring[j] == '\\' && fullString[i] == '/'))
        {
            combo++;
            if (j + 1 <= strlen(substring))
            {
                j++;
            }
            else
            {
                combo = 0;
                j = 0;
            }

        }
        else
        {
            combo = 0;
            j = 0;
        }
        if (combo == strlen(substring))
        {
            return 1;
        }
    }
    return 0;
}

int containsStartEnd(char* fullString, char* substring, int* start, int* end)
{
    if (strlen(substring) > strlen(fullString))
    {
        //printf("\nWarning: Wrong use of function 'contains(%s,%s)'. The first argument has to be longer than the second", fullString, substring);
        return 0;
    }
    int i = 0;
    int j = 0;
    int combo = 0;
    for (i = 0; i < strlen(fullString); i++)
    {
        if (substring[j] == fullString[i]
        || substring[j] + 32 == fullString[i]
        || substring[j] - 32 == fullString[i]
        || (substring[j] == '/' && fullString[i] == '\\')
        || (substring[j] == '\\' && fullString[i] == '/'))
        {
            combo++;
            if (j + 1 <= strlen(substring))
            {
                j++;
            }
            else
            {
                combo = 0;

                j = 0;
            }

        }
        else
        {
             (*start) = i + 1;
            combo = 0;
            j = 0;
        }
        if (combo == strlen(substring))
        {
            (*end) = (*start) + strlen(substring);
            return 1;
        }
    }
    return 0;
}

char* getFourDigits(char* fileName)
{
    int start = indexOf('_',fileName,2) + 1;
    int end = indexOf('_',fileName,3);
    int dot = indexOf('.',fileName,0);

    if (dot < end)
    {
        end = dot;
    }

    char* fourDigits = substr(fileName,start,end);

    return fourDigits;
}


void askConfirmation()
{
    printf("Do you want to proceed anyway? (y/n) ");
    char input[32] = "";
     while (strcmpi(input,"y") != 0 && strcmpi(input,"n") != 0)
     {
        fflush(stdin);
        scanf("%s", input);
        fflush(stdin);
     }

    if (strcmpi(input,"n") == 0)
    {
        printf("\nExiting.\n\n");
        system("PAUSE");
        exit(1);
    }
}

void createPath(char* pathToCreate)
{
    charReplace(pathToCreate,'/','\\');

    DIR* dir = opendir(pathToCreate);

    if (dir)
    {
        closedir(dir);
    }
    else
    {
        char* mdCommand = (char*) malloc(strlen("md \"%s\"") + strlen(pathToCreate) + 1);
        sprintf(mdCommand,"md \"%s\"",pathToCreate);
        //printf("\n%s\n",mdCommand);
        system(mdCommand);
        free (mdCommand);
    }
}

void backupMenu()
{
    int backupSelected = -1;

        long backupCount = 0;
        char** backupNames = getBackupList(&backupCount);
        if (backupCount > 0)
        {
            while (1)
            {
                 backupSelected  = selectBackup(backupNames, backupCount);

                 if (backupSelected == -1)
                 {
                     return;
                 }

                 if (backupSelected < 0 || backupSelected > backupCount - 1)
                 {
                    printf("\nInvalid option!\n\n");
                 }
                 else
                 {
                     break;
                 }
            }

            restoreBackup(backupNames[backupSelected]);
        }
        else
        {
             printf("No backup was found");
        }
        printf("\n");
        system("PAUSE");
}



char* getLatestBackup()
{
    long backupCount = 0;
    char** backups = getBackupList(&backupCount);
    if (backupCount == 0)
    {
        return "pad00000.meta";
    }
    return backups[backupCount - 1];
}

// Merges 2 strings into 1
char* concatenate (char* str1, char*str2)
{
    char* result = (char*)malloc(strlen(str1) + strlen(str2) + 1);
    strcpy(result,str1);
    strcat(result,str2);
    return result;
}


int isNumOrLetter(char c)
{
    if (c >= 'a' && c <='z')
    {
        return 1;
    }
    if (c >= 'A' && c <='Z')
    {
        return 1;
    }
    if (c >= '0' && c <='9')
    {
        return 1;
    }
    if (c == '_')
    {
        return 1;
    }
    return 0;
}

int hexToInt(char* hex)
{
   /*FILE* tmpFile = fopen("tmp.bin","wb");
   fwrite(hex,sizeof(int),1,tmpFile);
   int num = 0;
   rewind(tmpFile);
   fread(tmpFile)*/
   return 0;
}

char* intToHex(int x)
{
    char* hex = (char*) malloc(sizeof(int) + 1);
    sprintf(hex,"%d",x);
    return hex;
}

void printColor(char* stringToPrint, Color COLOR)
{
    if (isWindows10)
    {
        switch (COLOR)
        {
            case (RED):
            {
                printf("\033[31;1m%s\033[0m", stringToPrint);
            }break;
            case (GREEN):
            {
                printf("\033[32;1m%s\033[0m", stringToPrint);
            }break;
            case (YELLOW):
            {
                printf("\033[33;1m%s\033[0m", stringToPrint);
            }break;
        }
    }
    else
    {
        printf("%s", stringToPrint);
    }
}

void printBackgroundColor(char* stringToPrint, Color COLOR)
{
    switch (COLOR)
    {
        case (RED):
        {
            printf("\x1b[41;37m%s\x1b[0m",stringToPrint);
        }break;
        case (GREEN):
        {
            printf("\x1b[41;37m%s\x1b[0m",stringToPrint);
        }break;
        case (YELLOW):
        {
            printf("\x1b[41;37m%s\x1b[0m",stringToPrint);
        }break;
    }
}

void printFileBlock(FileBlock fileBlock)
{
    printf("\n%ld|%ld|%ld|offset:%ld|%s|%s",fileBlock.hash,fileBlock.folderNum,fileBlock.fileNum,fileBlock.metaOffset,fileBlock.folderName,fileBlock.fileName);
}

void addToStringArray(char* fileNameToAdd, char*** ref_stringArray, int* ref_arrraySize)
{
    // If the variable that holds the fileNames of the files that failed to patch hasn't been initialized yet
    if ((*ref_stringArray) == NULL)
    {
        (*ref_stringArray) = (char**) malloc(sizeof(char*));
    }
    else // If it has been initialized
    {
         // Increases the size
        (*ref_stringArray) = (char**) realloc((*ref_stringArray), (((*ref_arrraySize) + 1) * sizeof(char*)));
    }
    // Allocates memory to copy the failed file name
    (*ref_stringArray)[(*ref_arrraySize)] = (char*) malloc(strlen(fileNameToAdd) + 1);
    strcpy((*ref_stringArray)[(*ref_arrraySize)],fileNameToAdd); // Copies the name of the failed file

    (*ref_arrraySize)++;
}

int alreadyInStringArray(char* fileName,char** stringArray, int arrraySize)
{
    int i = 0;
    for (i = 0; i < arrraySize; i++)
    {
        if (strcmpi(stringArray[i],fileName) == 0)
        {
            return 1;
        }
    }
    return 0;
}

void printHex(char* str)
{
    int i = 0;
    printf("\n");
    for (i = 0; i < strlen(str); i++)
    {
        printf("%x ", str[i]);
    }
    printf("\n");
}


void charReplace(char* str,char token,char replace)
{
    int i = 0;
    for (i = 0; i < strlen(str); i++)
    {
        if (str[i] == token)
        {
            str[i] = replace;

        }
    }
}

void printNextAsHex(char* str,int start, int length)
{
    int i = 0;

    for (i = start; i < (start + length); i++)
    {
        printf("%x ", str[i]);
    }
    printf("\n");
}

void printNextAsDec(char* str,int start, int length)
{
    int i = 0;
    printf("\n");
    for (i = start; i < (start + length); i++)
    {
        printf("%d ", str[i]);
    }
    printf("\n");
}

void printIntAsHex(int num)
{
    char* converted = intToHex(num);
    printHex(converted);
}

int nextFourBytesAsInt(char* str, int startLocation)
{
    int i = 0;
    char fourBytes[5] = "";
    fourBytes[4] = '\0';
    for (i = 0; i < 4; i++)
    {
        fourBytes[i] = str[startLocation+i];
    }
    return hexToInt(fourBytes);
}

char* substr(char* str,int start, int end)
{
    if (end < start)
    {
        //printf("\ntrying to create a substring where end < start |  %s start: %d   end: %d\n", str, start, end);
        return "";
    }
    if (end == start)
    {
        return "";
    }
    char* sub = (char*) malloc((end - start) + 1);
    int j = 0;
    int i = 0;
    for (i = start; i <= end; i++)
    {
        sub[j] = str[i];
        j++;
    }
    sub[j - 1] = '\0';
    return sub;
}

int indexOf(char token, char* str, int skips)
{
    int i = 0;
    int skipped = 0;
    for (i = 0; i < strlen(str); i++)
    {
        if (str[i] == token)
        {
            if (skipped == skips)
            {
                return i;
            }
            else
            {
                skipped++;
            }
        }
    }
    return i -1;
}

long locateHash(long hash,MemFileInt* metaFileInMemory,MetaFileInfo* metaFileInfo)
{
    long currentBlock = 0;
    int readNum = 0;

    int startBlock = metaFileInfo->fileBlocksStart/sizeof(int);
    int endBlock = metaFileInfo->fileBlocksEnd/sizeof(int);

    for (currentBlock = startBlock; currentBlock < endBlock; currentBlock++)
    {
        readNum = metaFileInMemory->block[currentBlock];

        if(readNum == hash)
        {
            return currentBlock;
        }
    }
    return NOT_FOUND;
}


long locateIntInMemory(int intToLocate,MemFileInt* arrayInMemory, MetaFileInfo* metaFileInfo)
{
    long currentBlock = 0;
    int readNum = 0;

    for (currentBlock = 0; currentBlock < arrayInMemory->size; currentBlock++)
    {
        readNum = arrayInMemory->block[currentBlock];


        int startBlock = metaFileInfo->fileBlocksStart/sizeof(int);
        int endBlock = metaFileInfo->fileBlocksEnd/sizeof(int);


        if(readNum == intToLocate)
        {
            if ((currentBlock < startBlock || currentBlock > endBlock))
            {
                printf("                       OUTSIDE!");
                 return NOT_FOUND;
            }
            return currentBlock;

        }

    }
    return NOT_FOUND;
}

long locate2IntsInMemory(int int1, int int2 ,MemFileInt* arrayInMemory)
{
    //printf("\nlooking for: %.8x | %.8x\n", int1, int2);
    long currentBlock = 0;
    for (currentBlock = 0; currentBlock < arrayInMemory->size; currentBlock++)
    {

        if(arrayInMemory->block[currentBlock] == int1 && arrayInMemory->block[currentBlock + 1] == int2)
        {
            return currentBlock;
        }

    }
    return NOT_FOUND;
}



void undoLastChanges(int echo)
{

    FILE* metaFile = openFile("pad00000.meta","rb+");
    FILE* modFile = fopen(concatenate("patcher_resources\\",LATEST_MODIFICATIONS_FILE_NAME),"rb");
    if (modFile == NULL)
    {
        printf("\nNo latest modifications file detected.");
        fclose(metaFile);
        return;
    }

    printf("\n\nRestoring last changes:\n");
    if (getFileSize(modFile) == 0)
    {
        printf("\nNo changes to undo.");
        fclose(metaFile);
        fclose(modFile);
        return;
    }
    else
    {
        FileBlock* fileToRestore = (FileBlock*) malloc(1 * sizeof(FileBlock));
        int restored = 0;
        int failed = 0;
        long bytesWritten = 0;

        long hash_read_from_file = 0;

        while(fread(&fileToRestore->metaOffset,sizeof(long),1,modFile))
        {
            fread(&fileToRestore->hash,sizeof(long),1,modFile);
            fread(&fileToRestore->folderNum,sizeof(long),1,modFile);
            fread(&fileToRestore->fileNum,sizeof(long),1,modFile);

            int fileNameLen = 0;
            fread(&fileNameLen,sizeof(int),1,modFile);

            fileToRestore->fileName = (char*) malloc(fileNameLen + 1);

            fread(fileToRestore->fileName,fileNameLen,sizeof(char),modFile);
            fileToRestore->fileName[fileNameLen] = '\0';


            fseek(metaFile,fileToRestore->metaOffset,SEEK_SET);
            fread(&hash_read_from_file,sizeof(long),1,metaFile);

            fseek(metaFile,fileToRestore->metaOffset + sizeof(long),SEEK_SET);

            if (hash_read_from_file == fileToRestore->hash)
            {
                bytesWritten = fwrite(&fileToRestore->folderNum,sizeof(long),1,metaFile);
                if (bytesWritten != 1)
                {
                     printColor(" Failed  ", RED);
                     printf("%ld bytes written",bytesWritten);
                }
                bytesWritten = 0;
                bytesWritten = fwrite(&fileToRestore->fileNum,sizeof(long),1,metaFile);
                if (bytesWritten != 1)
                {
                     printColor(" Failed  ", RED);
                     printf("%ld bytes written",bytesWritten);
                }
                else
                {
                     restored++;
                    if(echo)
                    {
                       printColor("Restored ", YELLOW);
                       printf("Hash:%s - %s \n", endian_convert(hash_read_from_file), fileToRestore->fileName);
                    }
                }
            }
            else
            {
                printColor(" Failed  ", RED);
                printf("Hash:%s - %s (Expected: %s)\n", endian_convert(hash_read_from_file), fileToRestore->fileName, endian_convert((int)fileToRestore->hash));

                failed++;
            }
            if (fileToRestore->fileName != NULL)
            {
                free(fileToRestore->fileName);
            }
        }
        if(echo)
        {
           printf("\nRestored: \033[32;1m%d\033[0m   Failed: \033[31;1m%d\033[0m", restored, failed);
        }
        else
        {
            if (failed > 0)
            {
                printColor("\n\nWarning:",RED); printf(" Some files failed to be restored\n\n");
            }
            else
            {
                printf("Done.");
            }
        }


        fclose(modFile);
        remove(concatenate("patcher_resources\\",LATEST_MODIFICATIONS_FILE_NAME));
        fclose(metaFile);
    }
}


/*void toHex(int decimalNumber)
{
	int remainder;
	int quotient;
    int i=1,j;
    char hexadecimalNumber[100];

    quotient = decimalNumber;

    while(quotient!=0)
	{
         remainder = quotient % 16;

      //To convert integer into character
      if( remainder < 10)
           remainder = remainder + 48;		// Add 48(become ascii later) value to remainder if less than 10--see ascii table for more info
      else
         remainder = remainder + 55;		// Add 55(become ascii later) value to remainder if greater than 10--see ascii table for more info

      hexadecimalNumber[i++]= remainder;

      quotient = quotient / 16;
    }

    //printf("Equivalent hexadecimal value of %d is: ",decimalNumber);

    for(j = i -1 ;j> 0;j--)
    {
      printf("%c",hexadecimalNumber[j]);
    }

}

void printNextBytesAsHex(FILE* fp, int howManyBytes)
{
    int i = 0;
    char c;
    for (i = 0; i < howManyBytes; i++)
    {
        fread(&c,1,1,fp);
        printf("%x ", c);
    }
}*/



char** getBackupList(long* backupCount)
{
    return getFilesSingleFolder(getCurrentPath(),"backup",backupCount);
}

int selectBackup(char** backupNames, long backupCount)
{
    long i = 0;
     char input[32];
     int optionSelected = -1;
    int backupSelected = -1;

    printf("\n\nList of backups:\n");
    for (i = 0; i < backupCount; i++)
    {
       printf("%ld - %s\n", i + 1, backupNames[i]);
    }
    printf("0 - Back\n");
    while (1)
    {
        printf("\nSelect backup number: ");
        fgets(input,32,stdin);

        optionSelected = atoi(input);
        backupSelected = optionSelected - 1;

        if (optionSelected == EXIT)
        {
            return -1;
        }

        if (optionSelected < 0 || optionSelected > backupCount)
        {
            printf("\nInvalid option!\n\n");
        }
        else
        {
            break;
        }
    }

    return backupSelected;
}




void createBackup()
{
    if (!isClean("pad00000.meta"))
    {
        printf("\nFailed to create a backup\n");
        printf("\nYour pad00000.meta file is not clean");
        printf("\nPlease delete your \"version.dat\" file and let the launcher re-check all your game files");
       // PAUSE();
        return;
    }
    int backupNameLen = strlen("pad00000[YYYY-MM-DD].meta.backup");
    char* backupName = (char*)malloc(backupNameLen + 1);


    remove(concatenate("patcher_resources\\",LATEST_MODIFICATIONS_FILE_NAME));

    time_t now;
    time(&now);

    struct tm* now_tm;
    now_tm = localtime(&now);

    strftime (backupName, backupNameLen + 1, "pad00000[%Y-%m-%d].meta.backup", now_tm);

    char* cmd = (char*) malloc(strlen("copy pad00000.meta pad00000[YYYY-MM-DD].meta.backup") + 1);
    sprintf(cmd,"copy pad00000.meta %s", backupName);
    system(cmd);

    if (fileExists(backupName))
    {
        printf("\nA new backup was created: %s\n",backupName);
    }
    else
    {
        printf("\nCould not create a backup\n");
        printf("Try running the program as administrator\n");
        printf("\nThe program can try to proceed without that file, but it can crash\n\n");
        askConfirmation();
    }
    free(backupName);
    free(cmd);
}

int backupExists()
{
    long backupCount = 0;
    char** backups = getFilesSingleFolder(getCurrentPath(),"backup", &backupCount);

    if (backupCount == 1)
    {
        printf("%ld backup was found\n", backupCount);
    }
    else
    {
        printf("%ld backups were found\n", backupCount);
    }

    FILE* backupFile = NULL;
    FILE* metaFile = openFile("pad00000.meta","rb");

    int i = 0;
    for(i = 0; i < backupCount; i++)
    {
        backupFile = fopen(backups[i],"rb");
        if (getFileSize(backupFile) == getFileSize(metaFile))
        {
            long version_backup = -1;
            long version_metaFile = -1;
            fread(&version_backup,sizeof(long),1,backupFile);
            fread(&version_metaFile,sizeof(long),1,metaFile);
            fclose(metaFile);
            fclose(backupFile);

            if (version_backup == version_metaFile)
            {
                return 1;
            }
        }
        fclose(backupFile);
    }
    fclose(metaFile);
    return 0;
}

void restoreBackup(char* backupName)
{
    char command[2048];
    sprintf(command,"copy /y \"%s\" pad00000.meta",backupName);
    system(command);
    remove(concatenate("patcher_resources\\",LATEST_MODIFICATIONS_FILE_NAME));
}

//-----------------------------------------------------------------------------------------------------------------
void createLogFile()
{
    FILE* log = openFile("patcher_resources/paz_browser.log","wb");
    long lastMetafileSize = getFileSizeByName("pad00000.meta");
    fwrite(&lastMetafileSize,sizeof(long),1,log);
    fclose(log);
}

char* bdoRootFolder()
{
     return (oneLevelDown(getCurrentPath()));
}

void generateReferenceFile()
{
    printf("Generating reference file (it takes a while)...");
    char command[2048] = "";
    char* metaFileName = getLatestBackup();
    if (strlen(metaFileName) == 0)
    {
        metaFileName = (char*) malloc(strlen("pad00000.meta") + 1);
        strcpy(metaFileName,"pad00000.meta");
    }

    sprintf(command, "cd patcher_resources & quickbms.exe 2>NULL 1>reference_file.txt blackdesert_file_lister.bms \"%s", concatenate(getCurrentPath(),metaFileName));
    system(command);
    remove("NULL");

    long refFileSize = getFileSizeByName("patcher_resources/reference_file.txt");

    if (refFileSize < 20000000)
    {
        sprintf(command, "cd patcher_resources & quickbms.exe blackdesert_file_lister.bms \"%s", concatenate(getCurrentPath(),metaFileName));
        system(command);
        printf("\n\nFailed to generate reference_file_textures.txt, the reason is shown above\n");
        if (refFileSize != 0)
        {
            printf("  The program can try using the created reference_file.txt instead,\n");
            printf("  But it will not find a lot of files\n");
            askConfirmation();
        }
        else
        {
            printf("\nThe program cannot continue... Exiting");
            system("PAUSE");
            exit(1);
        }
    }
    else
    {
        printf("\nDone.\n\n");
    }
}

int metaFileChangedSize()
{
    long lastMetafileSize = 0;
    FILE* log = fopen("patcher_resources/paz_browser.log","rb");
    if (!log)
    {
        return 1;
    }
    fread(&lastMetafileSize,sizeof(long),1,log);

    if (lastMetafileSize != getFileSizeByName("pad00000.meta"))
    {
        fclose(log);
        return 1;
    }
    fclose(log);
    return 0;
}


char** getTexturesFrom(FileBlock* fileBlock, char* fileLocation, int* return_texture_count, FileBlock* fileBlocks, MetaFileInfo* metaFileInfo)
{
    printf("\nGetting Textures Names from %s...", fileBlock->fileName);
    char** textureNames = (char**)malloc(MAX_TEXTURES * sizeof(char*));
    int i = 0;
    for(i = 0; i < 256; i++)
    {
        textureNames[i] = (char*) malloc(MAX_PATH);
    }
    int texturesCount = 0;

    FILE* PACFile = openFile(concatenate(fileLocation,fileBlock->fileName), "rb");

    char c = '\0';
    int legibleCharCount = 0;
    int underlineCount = 0;
    char c_anterior = '\0';

    while (fread(&c,1,1,PACFile))
    {
         //printf("%c", c);
         if (texturesCount >= MAX_TEXTURES)
         {
             printf("\nWarning: The number of textures loaded exceeds the limit of %d!", MAX_TEXTURES);
             break;
         }

        if (isNumOrLetter(c) && legibleCharCount < MAX_PATH)
        {
            textureNames[texturesCount][legibleCharCount] = c;
            textureNames[texturesCount][legibleCharCount + 1] = '\0';
            legibleCharCount++;
        }
        else
        {
            if (underlineCount >= 2)
            {
                strcat(textureNames[texturesCount],".dds");

                for(i = 0; i < metaFileInfo->fileBlocksCount; i++)
                {
                    if (strcmpi(textureNames[texturesCount],fileBlocks[i].fileName) == 0)
                    {
                        printf("\nFound: %s",textureNames[texturesCount]);
                        texturesCount++;
                        break;
                    }
                }
            }
            legibleCharCount = 0;
        }
        if (legibleCharCount > 0)
        {
            if (c == '_' && c_anterior != '_')
            {
                underlineCount++;
            }
        }
        else
        {
            underlineCount = 0;
        }
        c_anterior = c;
    }
    if (texturesCount > 0)
    {
       /* printf("\n\nTextures Names found:");
        for (i = 0; i < texturesCount; i++)
        {
            printf("\n%s", textureNames[i]);
        }*/
    }
    printf("\n\n");
    (*return_texture_count) = texturesCount;
    fclose(PACFile);
    return textureNames;
}

int isPatched(FileBlock* fileBlock, MetaFileInfo* metaFileInfo)
{
    FILE* metaFile = openFile("pad00000.meta","rb");
    fseek(metaFile,fileBlock->metaOffset,SEEK_SET);
    int hashFound = 0;
    long hash = -1;
    fread(&hash,sizeof(long),1,metaFile);
    if (hash != fileBlock->hash)
    {
        while(ftell(metaFile) >= metaFileInfo->fileBlocksStart)
        {
            fseek(metaFile,((-2) * sizeof(long)), SEEK_CUR);
            fread(&hash,sizeof(long),1,metaFile);
            if (hash == fileBlock->hash)
            {
                hashFound = 1;
                break;
            }
        }
        if (hashFound == 0)
        {
            fseek(metaFile,fileBlock->metaOffset + sizeof(long),SEEK_SET);
            while(ftell(metaFile) < metaFileInfo->fileBlocksEnd)
            {
                fread(&hash,sizeof(long),1,metaFile);
                if (hash == fileBlock->hash)
                {
                    hashFound = 1;
                    break;
                }
            }
        }
    }
    else
    {
        hashFound = 1;
    }
    if (hashFound == 0)
    {
        fclose(metaFile);
        return 0;
    }
    else
    {
        long folderNum = -1;
        long fileNum = -1;
        fread(&folderNum,sizeof(long),1,metaFile);
        fread(&fileNum,sizeof(long),1,metaFile);

        if (folderNum == RANDOM_FOLDER_NUM && fileNum == RANDOM_FILE_NUM)
        {
            fclose(metaFile);
            return 1;
        }
        else
        {
            fclose(metaFile);
            return 0;
        }
    }
    fclose(metaFile);
    return 0;
}

int createMenu(MenuElements menu)
{
    char input = '\0';
    int optionSelected = -1;
    int i = 0;

     // Display the menu to select the region
    while(1) // This condition makes the menu repeat itself until a valid input is entered
    {
        system("cls"); // clears the screen
        printMainHeader();
        printf("%s\n", menu.header);
        for (i = 1; i <= menu.nOptions; i++)
        {
            printf("%d - %s\n",i, menu.menuoptions[i]);
        }
        printf("0 - %s\n", menu.menuoptions[0]);
        printf("\nEnter your choice: ");
        fflush(stdin);
        input = getch();

        if (input == ENTER ||  input == 10)
        {
            printf("\n");
            return 1;
        }

        // Converts the read string to int
        optionSelected = input - '0';

        // This variable also tells the program later which one of the "moddedBytes" the program should use when replacing the bytes

        if (optionSelected == 0)
        {
            return 0;
        }

         // If the user entered an invalid option, displays a error message
        if(optionSelected < 1 || optionSelected > menu.nOptions)
        {
            printf("\nInvalid option!\n\n");
            Sleep(500);
        }
        else
        {
            printf("\n");
            break;
        }
    }

    return optionSelected;
}

FileBlock* binarySearchFileBlock(char* key, FileBlock* fileBlocks, int fileblocksCount)
{
    int first = 0;
    int last = fileblocksCount - 1;
    int middle = (int)(first+last)/2;

    while (first <= last)
    {
        if (strcmpi(fileBlocks[middle].fileName,key) < 0)
        {
            first = middle + 1;
        }

        else if (strcmpi(fileBlocks[middle].fileName,key)  == 0)
        {
            return &fileBlocks[middle];
        }
        else
        {
            last = middle - 1;
        }

        middle = (first + last)/2;
   }
   if (first > last)
   {
      /*printf("Not found! %s is not present in the list.\n", key);
      system("PAUSE");*/
   }
   return NULL;
}

void PAUSE()
{
    printf("\n\n");
    system("PAUSE");
}


char* createArrowMenu(MenuElements menu, int* cursor)
{
    char input = '\0';
    if ((*cursor) < 0 || (*cursor) > menu.nOptions)
    {
        (*cursor) = 0;
    }
    int i = 0;

    while(1)
    {
        system("cls");
        printMainHeader();
        printf("%s\n\n", menu.header);
        for (i = 0; i <= menu.nOptions; i++)
        {
            if((*cursor) == i)
            {
               printf(" -> %s\n",menu.menuoptions[i]);
            }
            else
            {
                printf("    %s\n",menu.menuoptions[i]);
            }
        }


        printf("\n");
        printf("ENTER  - Confirm\n");
        printf("ARROWS - Change Selected Option\n");
        printf("ESC    - Go Back\n");


        input = getch();

        if (input == ENTER ||  input == 10)
        {
            break;
        }
        else if (input == ARROW_DOWN)
        {
            if ((*cursor) + 1 <= menu.nOptions)
            {
                (*cursor)++;
            }
            else
            {
                (*cursor) = 0;
            }
        }
        else if (input == ARROW_UP)
        {
            if ((*cursor) - 1 >= 0)
            {
                (*cursor)--;
            }
            else
            {
                (*cursor) = menu.nOptions;
            }
        }

        if (input == ESC)
        {
            return "Back";
        }

    }
    char* optionSelected = (char*) malloc(strlen(menu.menuoptions[(*cursor)]) + 1);
    strcpy(optionSelected,menu.menuoptions[(*cursor)]);

    return optionSelected;
}


PatcherState* loadPatcherState(char* patcherStateFileName)
{
    printf("Load patcher state:\n");
    PatcherState* patcherState = NULL;

    patcherState = (PatcherState*) calloc(1, sizeof(PatcherState));

     /** Patcher State Default values */
    int i = 0;
    for (i = 0; i < BODY_SIZE_N_OPTIONS; i++)
    {
        patcherState->bodyPartSize[i].min_size      = MIN_DEFAULT_SIZE;
        patcherState->bodyPartSize[i].default_size  = DEFAULT_DEFAULT_SIZE;
        patcherState->bodyPartSize[i].max_size      = MAX_DEFAULT_SIZE;
    }

    for (i = 0; i < TOTAL_WEAPON_OPTIONS; i++)
    {
        patcherState->weaponToRemove[i] = KEEP_ALL;
    }
    patcherState->weaponToRemove[SORCERESS] = BOTH_WEAPONS;

    FILE* patcher_state_file = fopen(concatenate("patcher_resources\\",patcherStateFileName), "rb");





    if (patcher_state_file != NULL)
    {
        if (getFileSize(patcher_state_file) == sizeof(PatcherState))
        {
            fread(patcherState,1,sizeof(PatcherState),patcher_state_file);
            printf("Success.\n");
        }
        else
        {
            printf("\nRestoring config from previous versions...\n");
            Sleep(500);
            if (getFileSize(patcher_state_file) == sizeof(PatcherState_2_8))
            {
                printf("v2.8 config file found.\n");

                PatcherState_2_8* patcherState_2_8 = (PatcherState_2_8*) malloc(1 * sizeof(PatcherState_2_8));
                fread(patcherState_2_8,1,sizeof(PatcherState_2_8),patcher_state_file);

                int i = 0;

                for (i = 0; i < 9; i++)
                {
                    patcherState->option[i] = patcherState_2_8->option[i];
                }

                for (i = 0; i < 5; i++)
                {
                    patcherState->pubicHair[i] = patcherState_2_8->pubicHair[i];
                }

                patcherState->transparentKibelius = patcherState_2_8->transparentKibelius;

                for (i = 0; i < 13; i++)
                {
                    patcherState->weaponToRemove[i] = patcherState_2_8->weaponToRemove[i];
                }

                for (i = 0; i < 13; i++)
                {
                    patcherState->removeWeaponInOnly[i] = patcherState_2_8->removeWeaponInOnly[i];
                }

                for (i = 0; i < 6; i++)
                {
                    if (i < ARMS)
                    {
                        patcherState->bodyPartSize[i] = patcherState_2_8->bodyPartSize[i];
                    }
                    else
                    {
                        patcherState->bodyPartSize[i+1] = patcherState_2_8->bodyPartSize[i];
                    }
                }
               Sleep(1000);
                printf("Success.\n");
               Sleep(1000);
            }
            else
            {

                printf("Unable to restore config.\n");
                Sleep(1500);
                system("cls");
                printf("\nIt seems that you are using a different version of the tool\n\n");
                printf("Your previously saved settings will be reseted\nto ensure the correct operation of this version.\n");
                printf("(Except your marked files, they will be kept)\n\n");
                printf("Do you want to continue?\n");
                printf("[ENTER] - Continue  [ESC] - Exit\n");
                char input = '\0';
                while(input != ENTER && input != 10 && input != ESC)
                {
                    input = getch();
                }
                if (input == ESC)
                {
                    exit(1);
                }
            }
        }
    }
    else
    {
        printf("Patch state file doesn't exists\n");
    }

    fclose(patcher_state_file);

    return patcherState;
}

void savePatcherState(PatcherState* patcherState,char* patcherStateFileName)
{
    FILE* patcher_state_file = fopen(concatenate("patcher_resources\\",patcherStateFileName), "wb");
    fwrite(patcherState,1,sizeof(PatcherState),patcher_state_file);
    fclose(patcher_state_file);
}


char* getClassAsString(FileBlock* fileBlock)
{
    char* classPrefix = getClassPrefix(fileBlock->fileName);

    if(strcmpi(fileBlock->fileName,"phw_01_nude_0001.dds") == 0)
    {
        return"   Sorceress/Valkyrie/Plum(Maehwa)\n           ";
    }

     if(contains(fileBlock->fileName,"0034")  && fileHasExt(fileBlock->fileName,"dds"))
     {
         return "   All Female";
     }

    if (strcmpi(fileBlock->fileName,"common_decals_road_04_dec.dds") == 0)
    {
        return "\t\"Blank\"";
    }

     if(contains(fileBlock->fileName,"customizationboneparamdesc"))
     {
         return " Extracting Breast Size Patcher XML Files...";
     }

    if (strcmpi(classPrefix,"phm") == 0)
    {
        return "\tWarrior";
    }
    else if (strcmpi(classPrefix,"phw") == 0)
    {
        return "\tSorceress";
    }
    else if (strcmpi(classPrefix,"pew") == 0)
    {
        return "\tRanger";
    }
    else if (strcmpi(classPrefix,"pgm") == 0)
    {
        return "\tBerserker";
    }
    else if (strcmpi(classPrefix,"pbw") == 0)
    {
        return "\tTamer";
    }
    else if (strcmpi(classPrefix,"pkm") == 0)
    {
        return "\tBlader (Musa)";
    }
    else if (strcmpi(classPrefix,"pvw") == 0)
    {
       return "\tValkyrie";
    }
    else if (strcmpi(classPrefix,"pwm") == 0)
    {
       return "\tWizard";
    }
    else if (strcmpi(classPrefix,"pww") == 0)
    {
       return "\tWitch";
    }
    else if (strcmpi(classPrefix,"pnw") == 0)
    {
        return "\tKunoichi";
    }
    else if (strcmpi(classPrefix,"pnw") == 0)
    {
        return "\tNinja";
    }
    else if (strcmpi(classPrefix,"pdw") == 0)
    {
        return "\tDark Knight";
    }
    else if (strcmpi(classPrefix,"pkww") == 0)
    {
        return "\tPlum (Maehwa)";
    }
    else if (strcmpi(classPrefix,"pkw") == 0)
    {
        return "\tPlum";
    }
    return "";
}

char* getArmorPartAsString(FileBlock* fileBlock)
{
    char* armorPart = getMiddleDigits(fileBlock->fileName);
    if (strcmpi(armorPart,"ub") == 0)
    {
         if (fileHasExt(fileBlock->fileName,"dds"))
         {
             if (contains(fileBlock->fileName,"0034"))
             {
                 return "Kibelius Armor";
             }
             return "Bra";
         }
        return "Upperbody";
    }

    else if (strcmpi(armorPart,"lb") == 0)
    {
         if (fileHasExt(fileBlock->fileName,"dds"))
         {
             return "Stocking";
         }
        return "Lowerbody";
    }
    else if (strcmpi(armorPart,"uw") == 0)
    {
        return "Underwear";
    }
    else if (strcmpi(armorPart,"hand") == 0)
    {
        return "Gloves";
    }
    else if (strcmpi(armorPart,"foot") == 0)
    {
        return "Boots";
    }
    else if (strcmpi(armorPart,"sho") == 0)
    {
        return "Shoulders";
    }
    else if (strcmpi(armorPart,"hel") == 0)
    {
       return "Helmets";
    }
    else if (strcmpi(armorPart,"cloak") == 0)
    {
       return "Cloak";
    }
    else if (contains(fileBlock->fileName,"treedummer"))
    {
       return "Treant Camouflage";
    }
    else if (contains(fileBlock->folderName,"event_costume"))
    {
       return "Event Costumes";
    }
    else if (contains(fileBlock->folderName,"weapon"))
    {
       return "Weapon";
    }
    if (contains(fileBlock->fileName,"nude"))
    {
       return "Nude";
    }

    return "";
}


FileBlock* searchFileBlock(char* fileName, FileBlock* fileBlocks, MetaFileInfo* metaFileInfo)
{
    int i = 0;
    for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
    {
        if (strcmpi(fileBlocks[i].fileName,fileName) == 0)
        {
            return &fileBlocks[i];
        }
    }
    printf("\n\nFile \"%s\" could not be found in the pad00000.meta file.\n\n\tThis could mean this file is part of the 8000 files that cannot be patched\n\tbecause their hashes are not present in the meta file.", fileName);
    PAUSE();
    return NULL;
}

FileBlock* searchFileBlockcontains(char* fileName, FileBlock* fileBlocks, MetaFileInfo* metaFileInfo)
{
    int i = 0;
    for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
    {
        if (contains(fileBlocks[i].fileName,fileName))
        {
            return &fileBlocks[i];
        }
    }
     printf("\n\nFile \"%s\" could not be found in the pad00000.meta file.\n\n\tThis could mean this file is part of the 8000 files that cannot be patched\n\tbecause their hashes are not present in the meta file.\n\n", fileName);
      PAUSE();
    return NULL;
}

int extractFileCustomPath(FileBlock* fileBlockSelected, char* extractionLocation, int echo)
{
    if(echo)
    {
        printf("\nExtracting %s to: %s\n", fileBlockSelected->fileName,extractionLocation);
    }

     if (!fileExists("patcher_resources\\quickbms.exe"))
    {
        printf("\n\nquickbms.exe is not located in the \"patcher_resources\\\" folder\n\n");
        system("PAUSE");
        free(extractionLocation);
        return 0;
    }

    /*if (strcmpi(extractionLocation,"patcher_resources\\") == 0)
    {
        strcpy(extractionLocation,"./");
    }*/

    char pazName[32];
    sprintf(pazName,"PAD%.5ld.PAZ",fileBlockSelected->pazNum);
    char* command = (char*) malloc(strlen("cd patcher_resources\\ & quickbms.exe  1>NULL 2>NULL2 -Y -f \"*%s*\" simple_extraction.bms \"../%s\" \"../%s") + strlen(fileBlockSelected->fileName) + strlen(pazName) + strlen(extractionLocation) + 256);
    if (echo)
    {
        sprintf(command,"cd patcher_resources\\ & quickbms.exe -Y -f \"*%s*\" simple_extraction.bms \"../%s\" \"../%s", fileBlockSelected->fileName,pazName,extractionLocation);
          printf("command: %s\n", command);
    }
    else
    {
        sprintf(command,"cd patcher_resources\\ & quickbms.exe  1>NULL 2>NULL2 -Y -f \"*%s*\" simple_extraction.bms \"../%s\" \"../%s", fileBlockSelected->fileName,pazName,extractionLocation);
    }

    system(command);
    free(command);
    remove("patcher_resources\\NULL");
    remove("patcher_resources\\NULL2");

    /*if (strcmpi(extractionLocation,"./") == 0)
    {
        extractionLocation = (char*) malloc(strlen("patcher_resources\\ ") + 1);
        strcpy(extractionLocation,"patcher_resources\\");
    }*/

    char* destPath = concatenate(extractionLocation,fileBlockSelected->fileName);

    //charReplace(destPath,'/','\\');

    if (!fileExists(destPath))
    {
        printf("\nError: Could find extracted file in:\n\"%s\"\n\n",destPath);
        system("PAUSE");
        return 0;
    }
    if (echo)
    {
        printf("\nSuccess: File extracted: \"%s\"\n",destPath);
    }
    free(destPath);
    free(command);
    return 1;
}

int extractFile(FileBlock* fileBlockSelected)
{
    char* extractionLocation = concatenate("patcher_resources\\extracted_files\\",substr(fileBlockSelected->fileName,0,strlen(fileBlockSelected->fileName)-3));
    extractionLocation[strlen(extractionLocation)-1] = '\\';

    return extractFileCustomPath(fileBlockSelected, extractionLocation,1);
}

char* captalizeFirstLetter(char* str)
{
    char* capStr = (char*) malloc(strlen(str) + 1);
    strcpy(capStr,str);
    if (capStr[0] >= 'a' && capStr[0] <= 'z')
    {
        capStr[0] -= 32;
    }
    return capStr;
}

void extractFileFromPaz(char* fileName, long pazNum, char* dest, int echo)
{
    char pazName[13];
    sprintf(pazName,"PAD%.5ld.PAZ", pazNum);
    char* command = (char*) malloc(strlen("cd patcher_resources\\ & quickbms.exe 1>NULL 2>NULL2 -Y -f \"*%s*\" blackdesert.bms ../%s \"%s") + strlen(fileName) + strlen(pazName) + strlen(dest) + 1);
    if (echo)
    {
        sprintf(command,"cd patcher_resources\\ & quickbms.exe -Y -f \"*%s*\" blackdesert.bms ../%s \"%s", fileName, pazName, dest);
        printf("\ncommand: %s\n", command);
    }
    else
    {
         sprintf(command,"cd patcher_resources\\ & quickbms.exe 1>NULL 2>NULL2 -Y -f \"*%s*\" blackdesert.bms ../%s \"%s", fileName, pazName, dest);
    }


    system(command);
    remove("patcher_resources\\NULL");
    remove("patcher_resources\\NULL2");
    free(command);
}

int getClassMacro(char* fileName)
{
    if (contains(fileName,"phm"))
    {
        return WARRIOR;
    }
    else if (contains(fileName,"phw"))
    {
        return SORCERESS;
    }
    else if (contains(fileName,"pew"))
    {
        return RANGER;
    }
    else if (contains(fileName,"pgm") || contains(fileName,"pgb"))
    {
        return BERSERKER;
    }
    else if (contains(fileName,"pbw"))
    {
        return TAMER;
    }
     else if (contains(fileName,"pkm"))
    {
        return BLADER;
    }
    else if (contains(fileName,"pvw"))
    {
        return VALKYRIE;
    }
    else if (contains(fileName,"pwm"))
    {
        return WIZARD;
    }
    else if (contains(fileName,"pww"))
    {
        return WITCH;
    }
    else if (contains(fileName,"pnw"))
    {
        return KUNOICHI;
    }
    else if (contains(fileName,"pnm"))
    {
        return NINJA;
    }
    else if (contains(fileName,"pdw"))
    {
        return DARK_KNIGHT;
    }
    else if (contains(fileName,"pkww") || contains(fileName,"pkw"))
    {
        return PLUM;
    }
    return NOT_FOUND;
}

void save_paz_browser_patcher_state(FileBlock* fileBlocks, MetaFileInfo* metaFileInfo, int operation)
{
    int i = 0;
    char comma = ',';

    FILE* paz_patcher_state_file = fopen(concatenate("patcher_resources\\", PAZ_BROWSER_PATCHER_STATE_FILE_NAME[operation]),"wb");
    FILE* red_markers_file       = fopen(concatenate("patcher_resources\\", PAZ_BROWSER_RED_MARKERS_FILE_NAME[operation]),"wb");

    for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
    {
        if (fileBlocks[i].needPatch == 1)
        {
            fwrite(fileBlocks[i].fileName,strlen(fileBlocks[i].fileName),sizeof(char),paz_patcher_state_file);
            fwrite(&comma,1,sizeof(char),paz_patcher_state_file);

            fwrite(&fileBlocks[i].changeID,sizeof(int),1,red_markers_file);
            fwrite(&fileBlocks[i].hash,sizeof(long),1,red_markers_file);
        }
    }
    fclose(paz_patcher_state_file);
    fclose(red_markers_file);
}

int getFileColor(long fileHash, int operation)
{
   FILE* red_markers_file = fopen(concatenate("patcher_resources\\", PAZ_BROWSER_RED_MARKERS_FILE_NAME[operation]),"rb");

    long blocksRead = 0;
    int color = -1;
    long hashRead = 0;
    if (red_markers_file != NULL)
    {
        while(1)
        {
            blocksRead = fread(&color,sizeof(long),1,red_markers_file);
            if (blocksRead == 0)
            {
                return 1;
            }
            if (color >= 0 && color <= 4)
            {
                blocksRead = fread(&hashRead,sizeof(long),1,red_markers_file);
                if (blocksRead == 0)
                {
                    return 1;
                }
            }
            else
            {
                hashRead = color;
                color = 2;
            }

            if (fileHash ==  hashRead)
            {
                return color;
            }
        }
    }
    return 1;
}

PazBrowserPatcherState* load_paz_browser_patcher_state(int* paz_browser_patcher_state_n_files, int operation)
{

    FILE* paz_patcher_state_file = fopen(concatenate("patcher_resources\\", PAZ_BROWSER_PATCHER_STATE_FILE_NAME[operation]),"rb");
    if (paz_patcher_state_file == NULL)
    {
        return NULL;
    }

    long fileSize = getFileSize(paz_patcher_state_file);
    if (fileSize == 0)
    {
        return NULL;
    }

    int i = 0;
    char c = '\0';
    for(i = 0; i < fileSize; i++)
    {
        fread(&c,1,1,paz_patcher_state_file);
        if (c == ',')
        {
            (*paz_browser_patcher_state_n_files)++;
        }
    }

    PazBrowserPatcherState* pazBrowserPatcherState = (PazBrowserPatcherState*) calloc(1,sizeof(PazBrowserPatcherState));

    pazBrowserPatcherState->fileName = (char**) malloc((*paz_browser_patcher_state_n_files) * sizeof(char*));

    (*paz_browser_patcher_state_n_files) = 0;

    MemFile* stateFileMem = copyFileToMemory(paz_patcher_state_file);

    char* fileName = strtok(stateFileMem->bytes,",");

    while(fileName != NULL && strlen(fileName) >= 1)
    {
        pazBrowserPatcherState->fileName[(*paz_browser_patcher_state_n_files)] = (char*) malloc(strlen(fileName));
        strcpy(pazBrowserPatcherState->fileName[(*paz_browser_patcher_state_n_files)],fileName);
        (*paz_browser_patcher_state_n_files)++;

        fileName = strtok(NULL,",");
    }
    fclose(paz_patcher_state_file);

    return pazBrowserPatcherState;
}

void clearFileBlocks(FileBlock* fileBlocks, MetaFileInfo *metaFileInfo)
{
    int i = 0;
    for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
    {
        fileBlocks[i].needPatch = 0;
        fileBlocks[i].changeID = 0;
    }
}

void extractTexturesFrom(FileBlock* fileBlockSelected, FileBlock* fileBlocks, MetaFileInfo* metaFileInfo)
{
    char* extractionPath = concatenate("patcher_resources\\extracted_files\\",substr(fileBlockSelected->fileName,0,strlen(fileBlockSelected->fileName)-3));
    extractionPath[strlen(extractionPath)-1] = '\\';

    if (!fileExists(concatenate(extractionPath,fileBlockSelected->fileName)))
    {
        extractFile(fileBlockSelected);
    }

    int texturesCount = 0;
    char** textureNames = getTexturesFrom(fileBlockSelected,extractionPath,&texturesCount,fileBlocks,metaFileInfo);

    if (texturesCount == 0 || textureNames == NULL)
    {
        printf("\nFailed to get textures from \"%s\"\n\n", fileBlockSelected->fileName);
        printf("Textures count = %d\n", texturesCount);
        system("PAUSE");
    }
    else
    {
        int i = 0;
        for(i = 0; i < texturesCount; i++)
        {
            FileBlock* textureFileBlock = searchFileBlock(textureNames[i],fileBlocks,metaFileInfo);
            if (textureFileBlock != NULL)
            {
                if (!fileExists(concatenate(extractionPath,textureFileBlock->fileName)))
                {
                    extractFileCustomPath(textureFileBlock,extractionPath,1);
                }
            }
        }

        // Open the extracted folder
        char* command2 = (char*) malloc(strlen("start %s") + strlen(extractionPath) + 1);
        sprintf(command2,"start %s", extractionPath);
        system(command2);
        Sleep(1000);
        free(command2);
        free(extractionPath);
    }
}

void copyBlankFiles(FileBlock* fileBlocks, MetaFileInfo* metaFileInfo)
{
    int i = 0;
    char* root = bdoRootFolder();
    int filesToPatch = 0;
    int pacFilePatched = 0;
    FileBlock* groundTextureBlock = NULL;
    printf("\nCopying \"Blank\" Files...\n\n");
    for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
    {
        if (fileBlocks[i].needPatch == 1)
        {
            filesToPatch++;

            // PAC FILE COPY
            if (fileHasExt(fileBlocks[i].fileName,"pac"))
            {
                // Replace every pac file marked to patch, with a ground model, which we removed the texture, so it's transparent
                copyFileTo("t0072_pumpkin_ground_0001.pac",fileBlocks[i].fileName,"patcher_resources/models/",concatenate(root,fileBlocks[i].folderName),1);
                pacFilePatched = 1;
            }
            // DDS FILE COPY
            else if (fileHasExt(fileBlocks[i].fileName,"dds"))
            {
               if (!contains(fileBlocks[i].fileName,"_ao.dds"))
                {
                    if (fileBlocks[i].size < 1000000)
                    {
                        copyFileTo("blank_dxt1.dds",fileBlocks[i].fileName,"patcher_resources/texture/",concatenate(root,fileBlocks[i].folderName),1);
                    }
                    else
                    {
                        copyFileTo("blank_dxt5.dds",fileBlocks[i].fileName,"patcher_resources/texture/",concatenate(root,fileBlocks[i].folderName),1);
                    }
                }
                else
                {
                    if (fileBlocks[i].size >= 600000)
                    {
                        copyFileTo("blank_ao_683.dds",fileBlocks[i].fileName,"patcher_resources/texture/",concatenate(root,fileBlocks[i].folderName),1);
                    }
                    else if (fileBlocks[i].size >= 170000 && fileBlocks[i].size < 600000)
                    {
                        copyFileTo("blank_ao_171.dds",fileBlocks[i].fileName,"patcher_resources/texture/",concatenate(root,fileBlocks[i].folderName),1);
                    }
                    else if (fileBlocks[i].size >= 43000 && fileBlocks[i].size < 170000)
                    {
                        copyFileTo("blank_ao_43.dds",fileBlocks[i].fileName,"patcher_resources/texture/",concatenate(root,fileBlocks[i].folderName),1);
                    }
                    else
                    {
                        printColor("        _ao file size mismatch\n",YELLOW);
                        copyFileTo("blank_ao_171.dds",fileBlocks[i].fileName,"patcher_resources/texture/",concatenate(root,fileBlocks[i].folderName),1);
                    }
                }
            }
        }

        if (strcmpi(fileBlocks[i].fileName,"common_decals_road_04_dec.dds") == 0)
        {
            groundTextureBlock = &fileBlocks[i];
        }
    }





    if (filesToPatch == 0)
    {
        printf("\nNo files to copy");
        PAUSE();
    }
    else
    {
         printf("\nDone.\n");

        if (pacFilePatched)
        {
            // printf("\nPatch common_decals_road_04_dec.dds");
            groundTextureBlock->needPatch = 1;
            //patchMetaFile(groundTextureBlock,1,REMOVE_A_FILE,metaFileInfo,1);
        }

    }
}

void getFilesFromTexture(char* textureName, FileBlock* fileBlocks, MetaFileInfo* metaFileInfo)
{
    if (textureName[strlen(textureName)-1] == '\n')
    {
        textureName[strlen(textureName)-1] = '\0';
    }
    printf("\nGetting files that contains: \"%s\"\n", textureName);
    char* extractionLocation = concatenate("patcher_resources\\extracted_files\\",textureName);
    charReplace(extractionLocation,'.','_');
    charReplace(extractionLocation,'\n','\\');

    if (extractionLocation[strlen(extractionLocation)-1] != '\\')
    {
        extractionLocation = concatenate(extractionLocation,"\\");
    }
    int i = 0;
    int j = 0;
    int filesCount = 0;
    int processedCount = 0;

    for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
    {
        if (fileHasExt(fileBlocks[i].fileName,"pac")
            && contains(fileBlocks[i].folderName,"1_pc")
            && !contains(fileBlocks[i].folderName,"weapon")
            && !contains(fileBlocks[i].folderName,"head")
            && !contains(fileBlocks[i].folderName,"etc")
            && !contains(fileBlocks[i].folderName,"40_glasses")
            && !contains(fileBlocks[i].folderName,"41_piercing")
            && contains(fileBlocks[i].fileName,"pnw"))
        {
            filesCount++;
        }
    }

    for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
    {
        if (fileHasExt(fileBlocks[i].fileName,"pac")
            && contains(fileBlocks[i].folderName,"1_pc")
            && !contains(fileBlocks[i].folderName,"weapon")
            && !contains(fileBlocks[i].folderName,"head")
            && !contains(fileBlocks[i].folderName,"etc")
            && !contains(fileBlocks[i].folderName,"40_glasses")
            && !contains(fileBlocks[i].folderName,"41_piercing")
            && contains(fileBlocks[i].fileName,"pnw"))
        {


            printf("(%d/%d)", processedCount + 1, filesCount);
            extractFileCustomPath(&fileBlocks[i],extractionLocation,1);
            int textureCount = 0;
            char** textures = getTexturesFrom(&fileBlocks[i],extractionLocation,&textureCount,fileBlocks,metaFileInfo);
            printf("\nExtracted");

            int found = 0;
            for (j = 0; j < textureCount; j++)
            {
                if (strcmpi(textures[j],textureName) == 0)
                {
                    printf("\n%s has your texture!", fileBlocks[i].fileName);
                    found = 1;
                    break;
                }
            }
            if (found)
            {
                 char* extractionLocation_PAC_FILE = concatenate(extractionLocation,fileBlocks[i].fileName);

                 // Replaces the folder name from filename.pac to filename/
                 for(j = 0; j < strlen(extractionLocation_PAC_FILE); j++)
                 {
                    if (extractionLocation_PAC_FILE[j] == '.')
                    {
                        extractionLocation_PAC_FILE[j] = '\\';
                        if (j + 1 < strlen(extractionLocation_PAC_FILE))
                        {
                            extractionLocation_PAC_FILE[j+1] = '\0';
                        }
                    }
                 }

                 createPath(extractionLocation_PAC_FILE);
                 moveFile(fileBlocks[i].fileName,extractionLocation,extractionLocation_PAC_FILE);

                 for (j = 0; j < textureCount; j++)
                 {
                     FileBlock* textureFileBlock = searchFileBlock(textures[j],fileBlocks,metaFileInfo);
                     if (textureFileBlock != NULL)
                     {
                         extractFileCustomPath(textureFileBlock,extractionLocation_PAC_FILE,0);
                     }
                 }
                char* command = (char*) malloc(strlen("start %s") + strlen(extractionLocation_PAC_FILE) + 1);
                sprintf(command,"start %s", extractionLocation_PAC_FILE);
                system(command);
                free(command);
                free(extractionLocation_PAC_FILE);

                PAUSE();
            }
            remove(concatenate(extractionLocation,fileBlocks[i].fileName));
            for (j = 0; j < MAX_TEXTURES; j++)
            {
                free(textures[j]);
            }
            free(textures);
            processedCount++;
            if (processedCount == filesCount)
            {
                break;
            }
        }
    }
       char* command = (char*) malloc(strlen("start %s") + strlen(extractionLocation) + 1);
        sprintf(command,"start %s", extractionLocation);
        system(command);
        free(command);
}

int isAFemaleFile(char* fileName)
{
    return (fileName[2] == 'w' || fileName[2] == 'W');
}

int isAMaleFile(char* fileName)
{
    return (fileName[2] == 'm' || fileName[2] == 'M');
}

int haveTheSameGender(char* fileName1, char* fileName2)
{
    return (fileName1[2] == fileName2[2]);
}

char* getOperationName(int operation)
{
    if (operation == REMOVE_A_FILE)
    {
       return "remove";
    }
    else if (operation == RESTORE_A_FILE)
    {
       return "restore";
    }
     else if (operation == FIX_HOLES)
    {
       return "fix";
    }
     else if (operation == GET_TEXTURES)
    {
       return "get textures from";
    }
    return "";
}

int isStockingTexture(char* fileName)
{
    int i = 0;

    for(i = 0; i < TOTAL_STOCKING_TEXTURES; i++)
    {
          //  printf("%s - %d\n",fileName, i);
        if (strcmpi(fileName,stockings[i]) == 0)
        {
            return 1;
        }
    }
    for(i = 0; i < TOTAL_STARTER_STOCKINGS; i++)
    {
        //printf("%s - %d\n",fileName, i);
        if (strcmpi(fileName,starterStockings[i]) == 0)
        {
            return 1;
        }
    }
  //  printf("\n\n");

    return 0;
}


long countPatchedFiles(FileBlock* fileBlocks, MetaFileInfo* metaFileInfo)
{
    printf("\nCounting patched files...");
    long filesPatched = 0;
    int i = 0;
    FileBlock* moddedFileBlocks = (FileBlock*) malloc(metaFileInfo->fileBlocksCount * sizeof(FileBlock));
    FILE* metaFile = openFile("pad00000.meta", "rb");
    /*FILE* patchesFilesList = openFile("patcher_resources\\patched_files.txt", "wb");
    char newLine = '\n';
    char comma = ',';*/

    fseek(metaFile,metaFileInfo->fileBlocksStart,SEEK_SET);

    for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
    {
        fread(&moddedFileBlocks[i].hash,sizeof(long),1,metaFile);
        fread(&moddedFileBlocks[i].folderNum,sizeof(long),1,metaFile);
        fread(&moddedFileBlocks[i].fileNum,sizeof(long),1,metaFile);
        fread(&moddedFileBlocks[i].pazNum,sizeof(long),1,metaFile);
        fread(&moddedFileBlocks[i].fileOffset,sizeof(long),1,metaFile);
        fread(&moddedFileBlocks[i].zsize,sizeof(long),1,metaFile);
        fread(&moddedFileBlocks[i].size,sizeof(long),1,metaFile);

        if ((moddedFileBlocks[i].folderNum == RANDOM_FOLDER_NUM) && (moddedFileBlocks[i].fileNum == RANDOM_FILE_NUM))
        {
            filesPatched++;
            /*moddedFileBlocks[i].isPatched = 1;

            if (fileBlocks[i].hash == moddedFileBlocks[i].hash)
            {
                fileBlocks[i].isPatched = 1;
                fwrite(fileBlocks[i].fileName,strlen(fileBlocks[i].fileName),sizeof(char),patchesFilesList);
                fwrite(&comma,1,sizeof(char),patchesFilesList);
                fwrite(&newLine,1,sizeof(char),patchesFilesList);
            }
            else
            {
                j = 0;
                while (((i - j) >= 0) && ((i + j) <= (metaFileInfo->fileBlocksCount - 1)))
                {
                    if (fileBlocks[i-j].hash == moddedFileBlocks[i].hash)
                    {
                        fileBlocks[i-j].isPatched = 1;
                        fwrite(fileBlocks[i-j].fileName,strlen(fileBlocks[i-j].fileName),sizeof(char),patchesFilesList);
                        fwrite(&comma,1,sizeof(char),patchesFilesList);
                        fwrite(&newLine,1,sizeof(char),patchesFilesList);
                        break;
                    }
                    if (fileBlocks[i+j].hash == moddedFileBlocks[i].hash)
                    {
                        fileBlocks[i+j].isPatched = 1;
                        fwrite(fileBlocks[i+j].fileName,strlen(fileBlocks[i+j].fileName),sizeof(char),patchesFilesList);
                        fwrite(&comma,1,sizeof(char),patchesFilesList);
                        fwrite(&newLine,1,sizeof(char),patchesFilesList);
                        break;
                    }
                    j++;
                }
            }*/
        }
    }

    if (filesPatched == 0)
    {
        rewind(metaFile);
        long readNum1 = -1;
        long readNum2 = -1;
        fread(&readNum1,sizeof(long),1,metaFile);
        while(1)
        {
            if (!fread(&readNum2,sizeof(long),1,metaFile))
            {
                break;
            }
            if (readNum1 == RANDOM_FOLDER_NUM && readNum2 == RANDOM_FILE_NUM)
            {
                filesPatched++;
            }
            readNum1 = readNum2;
        }
    }
    fclose(metaFile);
   // fclose(patchesFilesList);

    if (moddedFileBlocks != NULL)
    {
       free(moddedFileBlocks);
    }

    printf("\nDone.");

    return filesPatched;
}

int isClean(char* metaFileName)
{
    FILE* metaFile = openFile(metaFileName,"rb");
    long readNum1 = -1;
    long readNum2 = -1;
    long filesPatched = 0;
    fread(&readNum1,sizeof(long),1,metaFile);
    while(1)
    {
        if (!fread(&readNum2,sizeof(long),1,metaFile))
        {
            break;
        }
        if (readNum1 == RANDOM_FOLDER_NUM && readNum2 == RANDOM_FILE_NUM)
        {
            filesPatched++;
        }
        readNum1 = readNum2;
    }
    fclose(metaFile);
    return (filesPatched == 0);
}

void strreplace(char *target, const char *needle, const char *replacement)
{
    char buffer[1024] = { 0 };
    char *insert_point = &buffer[0];
    const char *tmp = target;
    size_t needle_len = strlen(needle);
    size_t repl_len = strlen(replacement);

    while (1) {
        const char *p = strstr(tmp, needle);

        // walked past last occurrence of needle; copy remaining part
        if (p == NULL) {
            strcpy(insert_point, tmp);
            break;
        }

        // copy part before needle
        memcpy(insert_point, tmp, p - tmp);
        insert_point += p - tmp;

        // copy replacement string
        memcpy(insert_point, replacement, repl_len);
        insert_point += repl_len;

        // adjust pointers, move on
        tmp = p + needle_len;
    }

    // write altered string back to target
    strcpy(target, buffer);

}


int isALetterOrNumber(char c)
{
    if ((c >= 'a' && c <= 'z')
        || (c >= 'A' && c <= 'Z')
        || (c >= '0' && c <= '9')
        )
    {
        return 1;
    }
    return 0;
}





